#pragma once

#include "CoreMinimal.h"
#include "AnimLayerUpdateInterface.h"
#include "BaseSurvivorAnimInstance.h"
#include "K41SurvivorSubAnimInstance.generated.h"

UCLASS(Blueprintable, NonTransient)
class THEK41_API UK41SurvivorSubAnimInstance : public UBaseSurvivorAnimInstance, public IAnimLayerUpdateInterface
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _hasBeenCurseHitWhenAlreadyCursed;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _hasBeenCurseHitWhenNotAlreadyCursed;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _hasBeenCursedByProjectile;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _hasBeenHitByProjectile;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _hasBeenCursedByGutsAttack;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _hasDamnedCurseEffect;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _hasDoomedCurseEffect;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	bool _isCrouched;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	bool _isIdle;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	bool _isHoldingHandleItem;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	bool _isHoldingFlashbang;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	bool _isHoldingFirecracker;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient)
	bool _isHoldingSmallItem;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _cursedByProjectileDuration;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _cursedByGutsAttackDuration;

public:
	UK41SurvivorSubAnimInstance();
};

FORCEINLINE uint32 GetTypeHash(const UK41SurvivorSubAnimInstance) { return 0; }
